﻿/// <reference path="viewModel.js" />

(function (lightSwitchApplication) {

    var $element = document.createElement("div");

    lightSwitchApplication.OrdersGridTemplate.prototype._$contentItems = {
        Tabs: {
            _$class: msls.ContentItem,
            _$name: "Tabs",
            _$parentName: "RootContentItem",
            screen: lightSwitchApplication.OrdersGridTemplate
        },
        OrderList: {
            _$class: msls.ContentItem,
            _$name: "OrderList",
            _$parentName: "Tabs",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.OrdersGridTemplate,
            value: lightSwitchApplication.OrdersGridTemplate
        },
        Order: {
            _$class: msls.ContentItem,
            _$name: "Order",
            _$parentName: "OrderList",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.OrdersGridTemplate,
            value: {
                _$class: msls.VisualCollection,
                screen: lightSwitchApplication.OrdersGridTemplate,
                _$entry: {
                    elementType: lightSwitchApplication.Order
                }
            }
        },
        RowTemplate: {
            _$class: msls.ContentItem,
            _$name: "RowTemplate",
            _$parentName: "Order",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: lightSwitchApplication.Order
        },
        OrderDate: {
            _$class: msls.ContentItem,
            _$name: "OrderDate",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: Date
        },
        RequiredDate: {
            _$class: msls.ContentItem,
            _$name: "RequiredDate",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: Date
        },
        ShippedDate: {
            _$class: msls.ContentItem,
            _$name: "ShippedDate",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: Date
        },
        ShipVia: {
            _$class: msls.ContentItem,
            _$name: "ShipVia",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: Number
        },
        Freight: {
            _$class: msls.ContentItem,
            _$name: "Freight",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipName: {
            _$class: msls.ContentItem,
            _$name: "ShipName",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipAddress: {
            _$class: msls.ContentItem,
            _$name: "ShipAddress",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipCity: {
            _$class: msls.ContentItem,
            _$name: "ShipCity",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipRegion: {
            _$class: msls.ContentItem,
            _$name: "ShipRegion",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipPostalCode: {
            _$class: msls.ContentItem,
            _$name: "ShipPostalCode",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        ShipCountry: {
            _$class: msls.ContentItem,
            _$name: "ShipCountry",
            _$parentName: "RowTemplate",
            screen: lightSwitchApplication.OrdersGridTemplate,
            data: lightSwitchApplication.Order,
            value: String
        },
        Popups: {
            _$class: msls.ContentItem,
            _$name: "Popups",
            _$parentName: "RootContentItem",
            screen: lightSwitchApplication.OrdersGridTemplate
        }
    };

    msls._addEntryPoints(lightSwitchApplication.OrdersGridTemplate, {
        /// <field>
        /// Called when a new OrdersGridTemplate screen is created.
        /// <br/>created(msls.application.OrdersGridTemplate screen)
        /// </field>
        created: [lightSwitchApplication.OrdersGridTemplate],
        /// <field>
        /// Called before changes on an active OrdersGridTemplate screen are applied.
        /// <br/>beforeApplyChanges(msls.application.OrdersGridTemplate screen)
        /// </field>
        beforeApplyChanges: [lightSwitchApplication.OrdersGridTemplate],
        /// <field>
        /// Called after the OrderList content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        OrderList_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("OrderList"); }],
        /// <field>
        /// Called after the Order content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Order_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("Order"); }],
        /// <field>
        /// Called after the RowTemplate content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        RowTemplate_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("RowTemplate"); }],
        /// <field>
        /// Called after the OrderDate content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        OrderDate_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("OrderDate"); }],
        /// <field>
        /// Called after the RequiredDate content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        RequiredDate_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("RequiredDate"); }],
        /// <field>
        /// Called after the ShippedDate content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShippedDate_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShippedDate"); }],
        /// <field>
        /// Called after the ShipVia content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipVia_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipVia"); }],
        /// <field>
        /// Called after the Freight content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        Freight_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("Freight"); }],
        /// <field>
        /// Called after the ShipName content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipName_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipName"); }],
        /// <field>
        /// Called after the ShipAddress content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipAddress_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipAddress"); }],
        /// <field>
        /// Called after the ShipCity content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipCity_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipCity"); }],
        /// <field>
        /// Called after the ShipRegion content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipRegion_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipRegion"); }],
        /// <field>
        /// Called after the ShipPostalCode content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipPostalCode_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipPostalCode"); }],
        /// <field>
        /// Called after the ShipCountry content item has been rendered.
        /// <br/>postRender(HTMLElement element, msls.ContentItem contentItem)
        /// </field>
        ShipCountry_postRender: [$element, function () { return new lightSwitchApplication.OrdersGridTemplate().findContentItem("ShipCountry"); }]
    });

}(msls.application));