﻿using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web;
using System.Web.Script.Serialization;
using System.Reflection;


namespace LightSwitchApplication.WebAPI
{
    public class GridExportController : ApiController
    {
               

        // GET api/<controller>
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        [System.Web.Http.ActionName("ExcelExport")]
        [AcceptVerbs("POST")]
        public void ExcelExport()
        {

            string gridModel = HttpContext.Current.Request.Params["GridModel"];

            GridProperties gridPropert = ConvertGridObject(gridModel);

            ExcelExport exp = new ExcelExport();

            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {
                IEnumerable data = context.DataWorkspace.NORTHWNDEntitiesData.Orders.Cast<OrderView>().Take(45).ToList();

                exp.Export(gridPropert, (IEnumerable)data, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-azure-dark");
            }
           
        }

        [System.Web.Http.ActionName("WordExport")]

        [AcceptVerbs("POST")]
 
        public void WordExport()
        {
            string gridModel = HttpContext.Current.Request.Params["GridModel"];

            GridProperties gridPropert = ConvertGridObject(gridModel);

            WordExport exp = new WordExport();

            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {

                IEnumerable data = context.DataWorkspace.NORTHWNDEntitiesData.Orders.Cast<OrderView>().Take(45).ToList();

                exp.Export(gridPropert, (IEnumerable)data, "Export.docx");
            }

        }

        [System.Web.Http.ActionName("PdfExport")]

        [AcceptVerbs("POST")]

        public void PdfExport()
        {
            string gridModel = HttpContext.Current.Request.Params["GridModel"];

            GridProperties gridPropert = ConvertGridObject(gridModel);

            PdfExport exp = new PdfExport();

            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {
                IEnumerable data = context.DataWorkspace.NORTHWNDEntitiesData.Orders.Cast<OrderView>().Take(45).ToList();

                exp.Export(gridPropert, (IEnumerable)data, "Export.pdf");
            }

        }

        private GridProperties ConvertGridObject(string gridProperty)
        {

            JavaScriptSerializer serializer = new JavaScriptSerializer();

            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));

            GridProperties gridProp = new GridProperties();

            foreach (KeyValuePair<string, object> ds in div)
            {

                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);

                if (property != null)
                {

                    Type type = property.PropertyType;

                    string serialize = serializer.Serialize(ds.Value);

                    object value = serializer.Deserialize(serialize, type);

                    property.SetValue(gridProp, value, null);

                }

            }

            return gridProp;

        }
    }

    public class OrderView
    {

        public int OrderID { get; set; }
        public double Freight { get; set; }
        public string ShipCity { get; set; }
        public DateTime OrderDate { get; set; }

    }

}