﻿/// <reference path="../GeneratedArtifacts/viewModel.js" />
myapp.OrdersGridTemplate.Order_render = function (element, contentItem) {
    // Write code here.
    var itemTemplate = $("<div></div>").attr('id', 'Order')

    // Append the div element to screen 
    itemTemplate.appendTo($(element));

    contentItem.value.oncollectionchange = function () {

        if (itemTemplate.hasClass('e-grid')) {
            itemTemplate.ejGrid('destroy');
        }
      
        //Rendering the Grid Control
        itemTemplate.ejGrid(
            {
                dataSource: ej.DataManager(contentItem.value.data),
                allowPaging: true,

                allowSelection: false,

                enableRowHover: false,

                columns: [

                              { field: "OrderID", headerText: "Order ID", isPrimaryKey: true, textAlign: ej.TextAlign.Right, width: 80 },

                              //{ field: "CustomerID", headerText: "Customer ID", textAlign: ej.TextAlign.Right, width: 80 },

                              //{ field: "EmployeeID", headerText: "Employee ID", textAlign: ej.TextAlign.Right, width: 80 },

                              { field: "Freight", headerText: "Freight", textAlign: ej.TextAlign.Right, width: 80, format: "{0:C}" },

                              { field: "OrderDate", headerText: "Order Date", width: 100, type: "date", textAlign: ej.TextAlign.Right },

                              { field: "ShipCity", headerText: "Ship City", width: 110, priority: 3 },

                ],

                toolbarClick: function (e) {

                    var gridObj = $("#Order").ejGrid('instance')

                    gridObj.exportGrid = gridObj["export"];

                    if (e.itemName == "Excel Export") {

                        gridObj.exportGrid('/api/GridExport/ExcelExport')

                        e.cancel = true;

                    }

                    else if (e.itemName == "Word Export") {

                        gridObj.exportGrid('/api/GridExport/WordExport')

                        e.cancel = true;

                    }

                    else if (e.itemName == "PDF Export") {

                        gridObj.exportGrid('/api/GridExport/PdfExport')

                        e.cancel = true;

                    }

                },

                toolbarSettings: { showToolbar: true, toolbarItems: [ej.Grid.ToolBarItems.ExcelExport, ej.Grid.ToolBarItems.WordExport, ej.Grid.ToolBarItems.PdfExport] }
            });
}
}