﻿/// <reference path="../Scripts/msls.js" />

window.myapp = msls.application;

(function (lightSwitchApplication) {

    var $Entity = msls.Entity,
        $DataService = msls.DataService,
        $DataWorkspace = msls.DataWorkspace,
        $defineEntity = msls._defineEntity,
        $defineDataService = msls._defineDataService,
        $defineDataWorkspace = msls._defineDataWorkspace,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString;

    function Customer(entitySet) {
        /// <summary>
        /// Represents the Customer entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this customer.
        /// </param>
        /// <field name="CustomerID" type="String">
        /// Gets or sets the customerID for this customer.
        /// </field>
        /// <field name="CompanyName" type="String">
        /// Gets or sets the companyName for this customer.
        /// </field>
        /// <field name="ContactName" type="String">
        /// Gets or sets the contactName for this customer.
        /// </field>
        /// <field name="ContactTitle" type="String">
        /// Gets or sets the contactTitle for this customer.
        /// </field>
        /// <field name="Address" type="String">
        /// Gets or sets the address for this customer.
        /// </field>
        /// <field name="City" type="String">
        /// Gets or sets the city for this customer.
        /// </field>
        /// <field name="Region" type="String">
        /// Gets or sets the region for this customer.
        /// </field>
        /// <field name="PostalCode" type="String">
        /// Gets or sets the postalCode for this customer.
        /// </field>
        /// <field name="Country" type="String">
        /// Gets or sets the country for this customer.
        /// </field>
        /// <field name="Phone" type="String">
        /// Gets or sets the phone for this customer.
        /// </field>
        /// <field name="Fax" type="String">
        /// Gets or sets the fax for this customer.
        /// </field>
        /// <field name="Orders" type="msls.EntityCollection" elementType="msls.application.Order">
        /// Gets the orders for this customer.
        /// </field>
        /// <field name="details" type="msls.application.Customer.Details">
        /// Gets the details for this customer.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function Employee(entitySet) {
        /// <summary>
        /// Represents the Employee entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this employee.
        /// </param>
        /// <field name="EmployeeID" type="Number">
        /// Gets or sets the employeeID for this employee.
        /// </field>
        /// <field name="LastName" type="String">
        /// Gets or sets the lastName for this employee.
        /// </field>
        /// <field name="FirstName" type="String">
        /// Gets or sets the firstName for this employee.
        /// </field>
        /// <field name="Title" type="String">
        /// Gets or sets the title for this employee.
        /// </field>
        /// <field name="TitleOfCourtesy" type="String">
        /// Gets or sets the titleOfCourtesy for this employee.
        /// </field>
        /// <field name="BirthDate" type="Date">
        /// Gets or sets the birthDate for this employee.
        /// </field>
        /// <field name="HireDate" type="Date">
        /// Gets or sets the hireDate for this employee.
        /// </field>
        /// <field name="Address" type="String">
        /// Gets or sets the address for this employee.
        /// </field>
        /// <field name="City" type="String">
        /// Gets or sets the city for this employee.
        /// </field>
        /// <field name="Region" type="String">
        /// Gets or sets the region for this employee.
        /// </field>
        /// <field name="PostalCode" type="String">
        /// Gets or sets the postalCode for this employee.
        /// </field>
        /// <field name="Country" type="String">
        /// Gets or sets the country for this employee.
        /// </field>
        /// <field name="HomePhone" type="String">
        /// Gets or sets the homePhone for this employee.
        /// </field>
        /// <field name="Extension" type="String">
        /// Gets or sets the extension for this employee.
        /// </field>
        /// <field name="Photo" type="String">
        /// Gets or sets the photo for this employee.
        /// </field>
        /// <field name="Notes" type="String">
        /// Gets or sets the notes for this employee.
        /// </field>
        /// <field name="PhotoPath" type="String">
        /// Gets or sets the photoPath for this employee.
        /// </field>
        /// <field name="Employees1" type="msls.EntityCollection" elementType="msls.application.Employee">
        /// Gets the employees1 for this employee.
        /// </field>
        /// <field name="Employee1" type="msls.application.Employee">
        /// Gets or sets the employee1 for this employee.
        /// </field>
        /// <field name="Orders" type="msls.EntityCollection" elementType="msls.application.Order">
        /// Gets the orders for this employee.
        /// </field>
        /// <field name="details" type="msls.application.Employee.Details">
        /// Gets the details for this employee.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function Order(entitySet) {
        /// <summary>
        /// Represents the Order entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this order.
        /// </param>
        /// <field name="OrderID" type="Number">
        /// Gets or sets the orderID for this order.
        /// </field>
        /// <field name="OrderDate" type="Date">
        /// Gets or sets the orderDate for this order.
        /// </field>
        /// <field name="RequiredDate" type="Date">
        /// Gets or sets the requiredDate for this order.
        /// </field>
        /// <field name="ShippedDate" type="Date">
        /// Gets or sets the shippedDate for this order.
        /// </field>
        /// <field name="ShipVia" type="Number">
        /// Gets or sets the shipVia for this order.
        /// </field>
        /// <field name="Freight" type="String">
        /// Gets or sets the freight for this order.
        /// </field>
        /// <field name="ShipName" type="String">
        /// Gets or sets the shipName for this order.
        /// </field>
        /// <field name="ShipAddress" type="String">
        /// Gets or sets the shipAddress for this order.
        /// </field>
        /// <field name="ShipCity" type="String">
        /// Gets or sets the shipCity for this order.
        /// </field>
        /// <field name="ShipRegion" type="String">
        /// Gets or sets the shipRegion for this order.
        /// </field>
        /// <field name="ShipPostalCode" type="String">
        /// Gets or sets the shipPostalCode for this order.
        /// </field>
        /// <field name="ShipCountry" type="String">
        /// Gets or sets the shipCountry for this order.
        /// </field>
        /// <field name="Customer" type="msls.application.Customer">
        /// Gets or sets the customer for this order.
        /// </field>
        /// <field name="Employee" type="msls.application.Employee">
        /// Gets or sets the employee for this order.
        /// </field>
        /// <field name="details" type="msls.application.Order.Details">
        /// Gets the details for this order.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function NORTHWNDEntitiesData(dataWorkspace) {
        /// <summary>
        /// Represents the NORTHWNDEntitiesData data service.
        /// </summary>
        /// <param name="dataWorkspace" type="msls.DataWorkspace">
        /// The data workspace that created this data service.
        /// </param>
        /// <field name="Customers" type="msls.EntitySet">
        /// Gets the Customers entity set.
        /// </field>
        /// <field name="Employees" type="msls.EntitySet">
        /// Gets the Employees entity set.
        /// </field>
        /// <field name="Orders" type="msls.EntitySet">
        /// Gets the Orders entity set.
        /// </field>
        /// <field name="details" type="msls.application.NORTHWNDEntitiesData.Details">
        /// Gets the details for this data service.
        /// </field>
        $DataService.call(this, dataWorkspace);
    };
    function DataWorkspace() {
        /// <summary>
        /// Represents the data workspace.
        /// </summary>
        /// <field name="NORTHWNDEntitiesData" type="msls.application.NORTHWNDEntitiesData">
        /// Gets the NORTHWNDEntitiesData data service.
        /// </field>
        /// <field name="details" type="msls.application.DataWorkspace.Details">
        /// Gets the details for this data workspace.
        /// </field>
        $DataWorkspace.call(this);
    };

    msls._addToNamespace("msls.application", {

        Customer: $defineEntity(Customer, [
            { name: "CustomerID", type: String },
            { name: "CompanyName", type: String },
            { name: "ContactName", type: String },
            { name: "ContactTitle", type: String },
            { name: "Address", type: String },
            { name: "City", type: String },
            { name: "Region", type: String },
            { name: "PostalCode", type: String },
            { name: "Country", type: String },
            { name: "Phone", type: String },
            { name: "Fax", type: String },
            { name: "Orders", kind: "collection", elementType: Order }
        ]),

        Employee: $defineEntity(Employee, [
            { name: "EmployeeID", type: Number, isReadOnly: true },
            { name: "LastName", type: String },
            { name: "FirstName", type: String },
            { name: "Title", type: String },
            { name: "TitleOfCourtesy", type: String },
            { name: "BirthDate", type: Date },
            { name: "HireDate", type: Date },
            { name: "Address", type: String },
            { name: "City", type: String },
            { name: "Region", type: String },
            { name: "PostalCode", type: String },
            { name: "Country", type: String },
            { name: "HomePhone", type: String },
            { name: "Extension", type: String },
            { name: "Photo", type: String },
            { name: "Notes", type: String },
            { name: "PhotoPath", type: String },
            { name: "Employees1", kind: "collection", elementType: Employee },
            { name: "Employee1", kind: "reference", type: Employee },
            { name: "Orders", kind: "collection", elementType: Order }
        ]),

        Order: $defineEntity(Order, [
            { name: "OrderID", type: Number, isReadOnly: true },
            { name: "OrderDate", type: Date },
            { name: "RequiredDate", type: Date },
            { name: "ShippedDate", type: Date },
            { name: "ShipVia", type: Number },
            { name: "Freight", type: String },
            { name: "ShipName", type: String },
            { name: "ShipAddress", type: String },
            { name: "ShipCity", type: String },
            { name: "ShipRegion", type: String },
            { name: "ShipPostalCode", type: String },
            { name: "ShipCountry", type: String },
            { name: "Customer", kind: "reference", type: Customer },
            { name: "Employee", kind: "reference", type: Employee }
        ]),

        NORTHWNDEntitiesData: $defineDataService(NORTHWNDEntitiesData, lightSwitchApplication.rootUri + "/NORTHWNDEntitiesData.svc", [
            { name: "Customers", elementType: Customer },
            { name: "Employees", elementType: Employee },
            { name: "Orders", elementType: Order }
        ], [
            {
                name: "Customers_SingleOrDefault", value: function (CustomerID) {
                    return new $DataServiceQuery({ _entitySet: this.Customers },
                        lightSwitchApplication.rootUri + "/NORTHWNDEntitiesData.svc" + "/Customers(" + "CustomerID=" + $toODataString(CustomerID, "String?") + ")"
                    );
                }
            },
            {
                name: "Employees_SingleOrDefault", value: function (EmployeeID) {
                    return new $DataServiceQuery({ _entitySet: this.Employees },
                        lightSwitchApplication.rootUri + "/NORTHWNDEntitiesData.svc" + "/Employees(" + "EmployeeID=" + $toODataString(EmployeeID, "Int32?") + ")"
                    );
                }
            },
            {
                name: "Orders_SingleOrDefault", value: function (OrderID) {
                    return new $DataServiceQuery({ _entitySet: this.Orders },
                        lightSwitchApplication.rootUri + "/NORTHWNDEntitiesData.svc" + "/Orders(" + "OrderID=" + $toODataString(OrderID, "Int32?") + ")"
                    );
                }
            }
        ]),

        DataWorkspace: $defineDataWorkspace(DataWorkspace, [
            { name: "NORTHWNDEntitiesData", type: NORTHWNDEntitiesData }
        ])

    });

}(msls.application));
